<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">

<HTML>

<HEAD>
<TITLE>Cours/TD - résumé2</TITLE>
<META NAME="GENERATOR" CONTENT="Arachnophilia 3.9">
<META NAME="FORMATTER" CONTENT="Arachnophilia 3.9">
<link REL="StyleSheet" TYPE="text/css" HREF="Costyle.css">

</HEAD>


<BODY BACKGROUND="../icons/reptile.jpg">

<CENTER><H1>Cours/TD - résumé (2)</H1>
</CENTER>
<P>
<p>
<TABLE width=100%>
 <TR><TD align=left><A HREF="comres1.html"><IMG SRC="../icons/gb_larr.gif" border=0 align=absmiddle></A></TD>
<TD align=right><A HREF="comres3.html"><IMG SRC="../icons/gb_rarr.gif" border=0 align=absmiddle></A></TD>
</TR>
</TABLE>

<p>

<H3><FONT COLOR=#ff0000>19.10.99</FONT></H3>
<p>
<H2>Cours - Continuation</H2>
<p>

Nous avons continué la préparation de nos "boîtes à outils" - une panoplie de techniques fonctionnelles utiles dans la programmation en général, et la construction des transducteurs en particulier. Ainsi, nous avons couvert une bonne partie de Haskell (avec une notable omission des <i>classes de types</i>, mais ça viendra...) à travers des exemples, qui seront <b>tous</b> utiles un jour.


<H3>Applications partielles ; "curryification"</H3><P>

On sait déjà qu'une application partielle d'un opérateur infixe :<TT>(/x)</TT> ou <TT>(2+)</TT> etc. est une expression légitime, un objet fonctionnel qui "attend" l'argument manquant. Ceci s'applique à toute fonction, par exemple si <TT>f x y z</TT>
est une expression légitime, l'expression <TT>f x y</TT> en est aussi, et ceci est équivalent à
<PRE>
\z -&gt; f x y z
</PRE><P>
Si en Lisp/Scheme au lieu d'écrire (f x y z) on écrit (f x y), le résultat est une erreur d'exécution - fonction appelée avec une liste erronée d'arguments. En Haskell cette expression <EM>ne se compile pas</EM>, car si le programme demande le résultat complet, disons de type <TT>a</TT>, alors l'application partielle possède le type <TT>b -&gt; a</TT>, où <TT>b</TT> est le type du troisième argument. Le vérificateur de types refuse de l'accepter.<p>

(Sauf, naturellement si <EM>nous voulons</EM> construire cet objet fontionnel, mais il doit se trouver dans un contexte correct. En Pascal une telle expression serait toujours erronée, et en C le problème de procédures qui acceptent des listes d'arguments de longueur variable, en général est ambigu).<p>


<H3>Techniques fonctionnelles d'ordre supérieur ; introduction aux combinateurs</H3><P>

Nous avons vu une dizaine d'exemples de fonctions qui parcourent les listes et en font quelque chose : réduisent par un opérateur binaire (p. ex. calculent la somme de tous les éléments d'une liste), transforment, filtrent, etc. La structure globale de plusieurs fonctions : inversion d'une liste, insertion, lecture d'un nombre (<A HREF="#lecnom">discuté en TD</A>) souvent exploite la même stratégie, seulement les détails changent. <EM>Ceci est la base de l'approche fonctionnelle à la modularité</EM> des programmes : si nous arrivons à "abstraire" le comportement indépendamment des données, le programme devient plus court, et ses fragments deviennent réutilisables. 
<span class=bl>D'autre part, ceci est également une manipulation qui facilite la compilation du programme !</span> Il nous en faut quelques exemples ... <p>

La <i>composition de deux transformations</i>, par exemple la définition
<PRE>
h x = sin (sqrt x)
</PRE><P>
est si omniprésente, qu'il serait utile de définir une abstraction "composition". Elle existe dans le Prélude standard, son opérateur est <TT>(.)</TT>, associatif à gauche, et sa définition est tout court
<PRE>
(f . g) x = f (g x)
</PRE><P>
pour tout <TT>f</TT> et <TT>g</TT>. Notre définition précédente devient <TT>h = sin . sqrt</TT>.<p>

La fonctionnelle bien connue dans le monde Lispien, le <TT>map</TT> (qui malheureusement souvent est <I>la seule</I> fonctionnelle enseignée...), dont la définition est bien connue :
<PRE>
-- map fonction liste
map _ [] = []
map f (x:xq) = f x : map f xq
</PRE><P>
satisfait quelques lois algébriques "combinatoires", indépendantes des arguments. Par exemple, si une liste <TT>l</TT> subit la transformation de ses éléments par la fonction <TT>f</TT>, et ensuite l'opération est répétée avec la fonction <TT>g</TT>, le résultat final peut être écrit comme
<PRE>
map2 f g l = map g (map f l)
</PRE><P>
qui syntaxiquement est une structure "imbriquée", même si intuitivement on a une sérialisation, séquentialisation des opérations :<P>
<IMG SRC="boites1.gif" WIDTH="558" HEIGHT="64" ALT="">
<P>
<I>Ce dessin est intuitivement mauvais, il faut que je le corrige : le flot de données entre de droite vers la gauche, contrairement aux flèches...</I><p>

On peut réécrire cette expression différemment : 
<PRE>
map2 f g l = (map f . map g) l
--   OU :
map2 f g = map f . map g
</PRE><P>
grâce à l'ordre normal d'évaluation, de gauche à droite, ce qui permet d'éliminer les arguments identiques de droite vers la gauche. Or, on peut essayer de composer les actions de <TT>f, g</TT> directement durant un seul parcours de la liste, ce qui donne 
<PRE>
map2 f g = map (f . g)
</PRE><p>
Notez que diagramme dessiné ci-dessus reste le même si les "boîtiers" symbolisent les fonctions et s'ils symbolisent les transducteurs de flots <TT>map</TT>. Naturellement, la version à gauche évite la création d'une liste intermédiaire, ainsi elle est plus efficace, cependant la modularisation séquentielle à droite peut être plus commode pour le programmeur. Souvent on construit un compilateur comme un transducteur à plusieurs étapes, écrites par de différents programmeurs, mais l'efficacité devient meilleure si on arrive à faire la "déforestation", l'élimination des flots (arbres) intermédiaires.
<p>

<CENTER>
<IMG SRC="../icons/an_colorbar.gif" WIDTH="600" HEIGHT="6" ALT="">
</CENTER><P>



La réduction d'une liste par un opérateur binaire, par exemple <TT>[2,4,7,0,3]</TT> <span class=sy>®</span> <TT>2+4+7+0+3 (+0)</TT>, ce qui peut être considéré comme le "remplacement" de <TT>(:)</TT> par l'addition, et de la liste vide par zéro, est un cas
particulier de <EM>catamorphisme</EM>, réalisé par la fonctionnelle <B>fold</B>, qui en Haskell existe en deux variantes :
<PRE>
--  foldr operateur val_initiale liste ;  "fold right"
foldr op z [] = z
foldr op z (x:xq) = op x (foldr op z xq)

-- foldl opérateur tampon list ;   "fold left"
foldl op z [] = z
foldl op z (x:xq) = foldl op (op x z) xq
</PRE><P>
et alors les définitions de la somme ou du produit des éléments d'une liste deviennent
<PRE>
sum l = foldl (+) 0 l
product l = foldl (*) 1 l
-- OU :
sum = foldl (+) 0
product = foldl (*) 1 
</PRE><P>
On peut naturellement utiliser <TT>foldr</TT> aussi, mais il <EM>doit être évident</EM> que la première solution est plus efficace, car récursive-terminale (itérative). Le fold est très universel. La concaténation peut être définie par
<PRE>
l1 ++ l2 = foldr (:) l2 l1
</PRE><P>
et
<PRE>
map f l = foldr (\a b -&gt; f a : b) [] l
</PRE><P>
et, bizarrement 
<PRE>
foldl f z l = foldr (b g a -&gt; g (f a b)) id l z
-- OÙ
id x = x       -- La fct. "identité". Cool, non?
</PRE><P>
<span class=re>Vérifiez cela SVP ! C'est important,</span> car au lieu d'itérer une opération sur la liste, on itère la <B>construction d'une fonction</B>, qui ensuite est appliquée une seule fois. Ceci est un "truc", mais montre une facette de la compilation moderne - la compilation dynamique des procédures.<p>
D'autres fonctionnelles existent. Voici comment filtrer un flot (liste), comment sélectionner tous les éléments qui satisfont une condition booléenne <TT>p</TT> :
<PRE>
filter p l = foldr (\a b -&gt; if p a then a:b else b)
</PRE><P>
plus explicitement :
<PRE>
filter _ [] = []
filter p (x:xq) | p x = x : filter p xq
                | otherwise = filter p xq
</PRE><P>
mais Haskell offre une autre notation, plus amicale (et un peu plus verbose, moins compacte). Un combinaison de <TT>map f l</TT> (transformateur qui peut être trivial) et le filtrage par <TT>p</TT> s'écrit sous forme qui s'appelle la <I>compréhension</I> :
<PRE>
[ f x | x &lt;- l, p x]
</PRE><P>

Et encore, la fonctionnelle (standard) qui filtre un flot d'une autre manière : accepte tous les éléments tant qu'une condition soit vérifiée, et ensuite, lors de son premier échec, arrête le parcours :
<PRE>
takeWhile p [] = []
takeWhile p (x:xq) | p x = x : takeWhile p xq
                   | otherwise = []
</PRE><P>
<EM>Essayez de définir cette fonction avec fold ...</EM><P>

Vous comprenez tout? Il faudra donc progresser, et maîtriser ce qui suit. Supposons que <TT>l</TT> soit une liste booléenne : <TT>[False, True, True, False, True, ...]</TT>, ce qui peut le résultat d'une application <TT>map condition</TT> à une liste quelconque. Si à présent nous voulons vérifier si <I>tous</I> les éléments soient vrais, ou <I>au moins un</I> - la conjonction et la disjonction logique sur toute la liste, nous pouvons définir (ceci appartient à la librairie standard) :
<PRE>
and l = foldr (&&) True  l
or  l = foldr (||) False l
</PRE><P>
et on se gratte la tête : <SPAN class=bl>Pourquoi <TT>foldr</TT>?</SPAN> On sait que <TT>foldl</TT> normalement est plus efficace, itératif. Cependant, d'autre côté, imaginons que la liste en question a un million d'éléments, et déjà le second est faux. Ce n'est pas la peine de parcourir la liste jusqu'à la fin pour voir que <TT>and</TT> va échouer, car il combine tous les successeurs de cet éléments avec <TT>False</TT>.<p>

Mais le miracle arrive. L'expression <TT>foldr (&&) True [True, False, True, True ...]</TT> se réduit à :
<PRE>
True && (foldr (&&) True [False, True, ...])
</PRE><P>
et le "et" logique doit évaluer le second argument. Mais celui-là est réduit à
<PRE>
False && (foldr (&&) [True, ...])
</PRE><P>
et maintenant l'évaluateur <EM>n'a pas besoin de second argument</EM> du tout ! On sait que le résultat sera faux. Ainsi le protocole paresseux nous sauve la vie, le parcours paresseux remplace une boucle avec une condition d'arrêt dynamique. <p>

<blockquote class=bl>
Réitérons l'idée principale. La programmation fonctionnelle pour nous est un mécanisme de définition formelle de fonctions, d'expressions de nature mathématique, statique. Mais la programmation c'est le dynamisme même, c'est l'activité. Le temps passe, les opérations se suivent, quelques unes sont redondantes (voire stupides) comme l'évaluation boléenne inutile si le résultat est connu à l'avance. La sémantique paresseuse nos donne des moyens d'intégrer ces deux mondes, d'avoir une expression courte et propre, et qui soit raisonnablement efficace.
</blockquote><p>
<p>


<H3>Filtrage et unification</H3><P>

Le filtrage (<i>pattern-matching</i>) qui déstructure automatiquement les arguments est très utile, mais pas très puissant. On ne peut pas definir une fonction avec la clause <TT>f x x = ...</TT>, ce qui doit vérifier que les deux arguments soient identiques. Il faut écrire <TT>f x y | x==y = ...</TT>. <p>

Cependant un mécanisme plus puissant, <EM>l'unification</EM> est utilisé en permanence par les programmes en Prolog et autres langages logiques. La <EM>programmation logique</EM> (qui fait sujet d'un autre cours en maîtrise) est basée sur quelques principes extrêmement simples, mais suffisamment distincts de la programmation classique pour que on lui consacre quelques mots ici. Les "entités" dans un programme classique, ce sont les variables, constantes, expressions (applications fonctionnelles), les fonctions ou procédures elles-même (objets fonctionnels), et les structures de controle. En Prolog nous avons encore <EM>les prédicats</EM>, les objets qui décrivent les relations n-aires entre les arguments, p. ex. : <TT>predic(A,B,C,D)</TT> affirme l'existence de la relation entre A, B, etc. En Prolog les noms des <I>variables</I> commencent par une lettre majuscule, sinon c'est une constante lexicale - symbole avec ou sans interprétation, mais considéré défini (instancié). Une relation peut représenter une fonction, p. ex. entre les n-1 premiers arguments et le dernier. Les paramètres d'une relation peuvent être des <B>patterns</B>, et Prolog était le premier langage <I>populaire</I> qui disposait de cet outil.<p>

Voici la concaténation de deux listes en Prolog ; la notation est semblable à  celle de Haskell : <TT>[a,b,c,d =, ...]</TT>, mais <TT>(x:y)</TT> est réécrit comme <TT>[x|y]</TT>.
<PRE>
append([],L,L). 
append([X|Xq],L,[X|R]):- append(Xq,L,R).
</PRE><P>
Comparez cela avec la notation fonctionnelle : 
<PRE>
(++) [] l = l
(++) (x:xq) l = x : (++) xq l
</PRE><P>
En Prolog un pattern peut représenter le résultat de sortie, et les arguments peuvent partager les noms de ses composantes. Le système considère que les objets de même nom sont identiques et lance l'unification complète, qui ne sera pas discutée en détail. Répétons - Haskell n'utilise pas l'unification pour filtrer les patterns, mais <EM>il faut savoir que le compilateur peut l'utiliser pour l'inférence de types</EM>. <br>
<span class=blu>Exercice.</span> Essayez d'inférer le type de la fonction <TT>a</TT>, comme il a été suggéré, et analysez la possibilité d'automatiser votre raisonnement :
<PRE>
a n m s z = n s (m s z)
</PRE><P>


<H3>Continuations</H3><P>

<A HREF="#contin">Ce sujet a été abordé en TD</A>. On est très loin de l'épuiser.


<!-- ********************************************************* --><p>
<CENTER><IMG SRC="../icons/limarro.gif" WIDTH="576" HEIGHT="9" ALT="">
</CENTER>
<p>

<p>
<H2>TD</H2>
<p>

<a name="lecnom">
<H3>Lecture d'un nombre entier</H3>
</a>
<P>

Le premier exercice était : étant donnée une chaîne de caractères dont le préfixe est numérique, par exemple : <TT>"54021 @~! Belle Marquise"</TT>, écrire un programme <TT>rdint</TT> qui lit cette chaîne et la transforme en nombre 54021 (si la base par défaut est décimale, mais une généralisation éventuelle est assez simple).
La librairie standard de Hugs contient la fonction <TT>ord</TT> qui transforme un caractère en son code ASCII, p. ex. <TT>ord 'a' = 97</TT>. Construisons d'abord deux fonctions auxiliaires, le convertisseur des caractères numériques, et le vérificateur :
<PRE>
toDig c = ord c - 48
isDig c = x &gt; 47 && x &lt; 58 where x=ord c
</PRE><p>
Le reste est une boucle qui accumule les chifffres lus en les "décalant vers la gauche", càd : en multipliant le nombre déjà construit par 10 et en ajoutant le chiffre suivant. Voici le code restant :
<PRE>
rdInt l = rdi l 0 where
  rdi (c:cq) t | isDig c = rdi cq (10*t+toDig c)
               | otherwise = t

res = rdInt txt
</PRE><p>
L'importance de cet exercice est évidente : ceci est un example de <i>scanneur</i>, ou analyseur lexical, qui construit mots, nombres, et autres unités lexicales irreductibles, comme les commentaires, opérateurs composites genre <TT>!=</TT> etc.<p>

La fonction <TT>rdint</TT> a la forme d'une boucle itérative avec une variable-tampon, et on peut se demander si les fonctionnelles génériques de type "fold" ne peuvent être applicables ici. Directement non, <TT>foldl</TT> s'arrête en fin de liste, et non pas après avoir constaté l'échec d'une condition. Mais nous pouvons utiliser <TT>takeWhile</TT>.
<p>
La version modularisée, écrite sans tenir compte de l'efficacité de bas niveau, qui génère les listes intermédiaires inutiles est plus simple et lisible (bon... pour quelques uns ...). Donc, on procède par étapes. D'abord on coupe le préfixe numérique (l'exemple donne <TT>"5421"=['5','4','0','2','1']</TT>. Ensuite la liste de caractères est transformée en liste de nombres (chiffres), et seulement après réduite :
<PRE>
rdint l = let l1 = takeWhile isdigit l
              l2 = map todigit l1
              op x tmp = x + 10*tmp
          in foldl op 0 l2
</PRE><P>
et ceci peut s'écrire de manière un peu plus perverse :
<PRE>
rdint = (foldl (\x t-&gt;x+10*t 0) . 
          ( (map toDigit) . (takeWhile isDigit) ) 
</PRE><P>


<H3>Lecture d'un flottant ; impression d'un entier</H3><P>

Essayons à présent lire un nombre qui peut contenir un point décimal, p. ex. : <TT>"407.7610"</TT>.<p>

Il faut compliquer la solution précédente, séparer le cas "." d'un autre caractère, et utiliser une deuxième procédure pour la lecture de la partie fractionnelle. En suivant notre philosophie de faire une petite chose à la fois, et intégrer l'ensemble plus tard, écrivons une procédure qui lit <i>seulement</i> la partie fractionnelle, et la transforme en fraction décimale. On considère que la liste contient déjà, et seulement les chiffres convertis en entiers 0-9 (ce qui peut être fait par les "boîtiers" précédents). Cette fois c'est le chiffre lu qui sera "décalé vers la droite" (divisé par une puissance de 10). Voici le code :
<PRE>
--   rdfrac liste_num  -&gt; nombre
rdfrac l = rdf l 0.0 0.1 where
  rdf [] t _ = t
  rdf (x:xq) t dv = rdf xq (t+x*dv)  (0.1*dv)
</PRE><P>
ce qui peut être écrit comme un catamorphisme <TT>fold</TT>, mais c'est délicat, car chaque passe fait <i>deux choses</i> : modifie le tampon et le diviseur. La solution n'est pas extraordinaire sur le plan de lisibilité, et nous la laissons aux lecteurs. ceci est un joli sujet d'examen...
<P>
Finalement, l'impression. Le nombre 50238 doit se transformer en <TT>"50238"</TT>, mais occupons-nous seulement de la conversion en liste de chiffres numériques. Le dernier chiffre est facile à séparer par l'opération <TT>mod</TT>, et ce qui reste sera divisé par 10.
<PRE>
intpr 0 = [0]
intpr n = ip n [] where
  ip 0 t = t
  ip n t = ip (n `div` 10) (n `mod`10 : t)
</PRE><P>



<H3>Définition de la puissance x<sup>n</sup></H3><P>

Il est plutôt inefficace d'organiser le calcul de <B>x</B><sup>60</sup> comme une boucle qui multiplie 60 fois (59 exactement) le <B>x</B> par soi-même. Une procédure plus efficace (normalement) consiste à exploiter l'identité : <span class=fl>x<SUP>2n</SUP> = (x<SUP>n</SUP>)<SUP>2</SUP> = (x<SUP>2</SUP>)<SUP>n</SUP></span>. Omettons les essais imparfaits et très instructifs élaborés en TD, et présentons la forme itérative finale
<PRE>
power _ 0 = 1
power x n = pow x n 1 where
  pow x 1 t = x*t    --(pow x 0 t = t -- si l'on veut)
  pow x n t | even n = pow (x*x) (n `div`2) t
            | otherwise = pow x (n-1) (x*t)
</PRE><P>



<a name="contin">
<H3>Introduction aux continuations</H3>
</a>
<P>
<B>Ceci est un sujet un peu difficile...</B> La notion de <i>continuation</i> permet de "formaliser le temps" dans un monde fonctionnel, donc assez statique, "mathématique", où on définit des structures respectant quelques lois, et où on peut prouver beaucoup de choses. Pour toute expression <B>e</B>, le compilateur doit prévoir son "futur", doit répondre explicitement à la question : <i>on évalue cet <B>e</B>, mais que fait-on ensuite?</i><p>

On passe le résultat à l'opérateur (fonction) dont <B>e</B> était l'argument, etc. Rien à ajouter. Mais dans le monde de la programmation impérative, d'autres réponses sont attendues. On exécute un instruction, et après? Bien sûr, on passe à "l'instruction suivante". Et si l'instruction en question est un branchement (<B>goto</B>)? Alors le "futur", la continuation, n'a plus rien à voir avec les instructions qui suivent statiquement le branchement dans le programme. Pouvons-nous représenter cela en utilisant le formalisme fonctionnel, propre?<p>

Analysons l'instruction <TT>res=sqrt(x<SUP>2</SUP>+y<SUP>2</SUP>)</TT>. Nous pouvons dessiner l'arborescence, ou le code postfixe : <TT>x x * y y * + sqrt</TT>, mais nous pouvons aussi écrire l'évaluation en assembleur. Ici l'assembleur est un langage où on ne peut pas écrire des expressions composites, mais seulement exécuter <I>une</I> opération à la fois, et stocker le résultat dans un registre (nommé). Donc, voici le code :
<PRE>
a = x*x
b = y*y
c = a+b
res = sqrt c
</PRE><P>
C'est un code de bas niveau, adapté à <EM>une machine à registres</EM>, un modèle différent d'une machine à pile, mais/et parfaitement réaliste et professionnel. Essayons de trouver un moyen de transformer (automatiquement, si possible, tel est l'objectif final) notre expression originale en code sérialisé.<p>

<B>Idée fondamentale :</B> (et un peu <I>cum grano salis</I>...) Toute expression <B>e</B> se transforme en <B>c (e)</B>, où <B>c</B> est une fonction qui "fait quelque chose avec le résultat <B>e</B>". Tout appel fonctionnel <TT>f x</TT> devient - symboliquement parlant - l'appel à une fonction "liftée", ou "continuée" <TT>f_c</TT> qui prend un paramètre supplémentaire, la continuation <TT>cnt</TT> : <br>
<TT>f_c x cnt = cnt (f x)</TT>.<p>

On applique cette méthode à toutes les opérations primitives (et même au chargement des arguments, mais ici on ne va pas si loin, bien qu'il faut savoir que "x" (la valeur de) dans un programme en assembleur peut avoir la forme "LOAD X REG0" ou une autre charabia de ce genre...). La définition <TT>fun x y = sqrt (x*x + y*y)</TT>
devient
<PRE>
fun x y res_cnt = 
 mul_c x x (\a -&gt; 
 mul_c y y (\b -&gt;
 add_c a b (\c -&gt;
 sqrt_c c res_cnt)))
</PRE><P>
Cela nos rappelle quelque chose n'est-ce pas? Ici la transformation CPS (<I>continuation passing style</I>) a été effectué manuellement, mais (en principe) on peut essayer de l'automatiser, de "lifter" les opérations définies par l'utilisateur, ce qui aplâtit le code, permet l'usage des registres, et économise l'usage de la pile, dont la manipulation est toujours légèrement moins efficace (tests, adressage indirecte, etc.) que les registres du processeur.<p>

La technique CPS sert également dans la programmation "normale" (et non seulement dans la construction des compilateurs fonctionnels), comme un outil d'optimisation. On y reviendra.



<H3>Exercice</H3><P>

J'ai offert une bouteille de champagne à ceux qui trouveront (en Haskell) une solution plus efficace, plus rapide et plus compacte que la mienne (dévoilée dans, disons, 10 jours) de problème suivant :<p>

Si le nombre réel <i>x</i> est petit, beaucoup petit que 1, la valeur de sin(<I>x</I>) s'approche de <i>x</i>. Supposons que <i>x</i> soit plus grand, mais sa valeur appartient à l'intervalle <SPAN class="sy">0 - 2p</SPAN>, donc, on n'a pas besoin de réduction résultant des propriétés trigonométriques classiques de la fonction sin. On utilisera la formule récursive suivante :

<p class=fe>
 sin(3x) = 3 sin(x) - 4 sin<sup>3</sup>(x)
</p>
<p>
qui divise l'argument par 3 s'il est trop grand. On peut choisir un <SPAN class="sy">e</SPAN> qui stoppe la récursivité, et c'est tout. La solution doit être itérative, mais - sauf si vous connaissez les "trucs", commencez par l'implantation directe, et essayez de l'optimiser.


<p>
<TABLE width=100%>
 <TR><TD align=left><A HREF="comres1.html"><IMG SRC="../icons/gb_larr.gif" border=0 align=absmiddle></A></TD>
<TD align=right><A HREF="comres3.html"><IMG SRC="../icons/gb_rarr.gif" border=0 align=absmiddle></A></TD>
</TR>
</TABLE>
<p>



</BODY>

</HTML>
